
/**
 * Write a description of class Lory here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Lory extends AbstractCar
{
    // instance variables - replace the example below with your own
    private int maxLoad; //the maximum amount of cargo
    private int load; //amount of load on board

    /**
     * Constructor for objects of class Lory
     * @param type truck type
     * @param maxLoad the maximum amount of the cargo
     * @param load initial amount of cargo to be loaded. When load &gt; maxLoad 
     *             then only maxLoad of cargo is loaded.
     */
    
    public Lory(String type, int maxLoad, int load,
               double emptyConsumption,int tankCapacity, double fuel)
    {
        super(emptyConsumption, type, tankCapacity,fuel);
        this.maxLoad = maxLoad;
        this.load = load;
    }
        
    /**
     * Returns String representation of the particular Lory
     * @return String representation in the form:
     *                 "<type> (maxLoad): <load> tons\n"
     */
    
    public String toString()
    {
        return super.toString()+" load: " + load + "(" + maxLoad +")";
    }
    
    /**
     * Returns the fuel consumption of the car. 
     * @return fuel consumption based on the formula 
     * emptyConsumption + 0.5*load
     */
    public double getConsumption()
    {
        return getEmptyConsumption() + 0.5 * load;
    }
    
    public int unload(int load)
    {
        int unloaded;
        
        if( this.load > load )
        {
            unloaded = load;
            this.load -= load;
        }
        else
        {
            unloaded = this.load;
            this.load = 0;
        }
        return unloaded;
    }
    
    public int load(int load)
    {
        int loaded;
        
        if( this.load + load <= maxLoad )
        {
            loaded = load;
            this.load += load;
        }
        else
        {
            loaded = maxLoad - this.load;
            this.load = maxLoad;
        }
        return loaded;
    }
    
}
